# DevOps Interview Questions


## Table of Contents

  1. [Jenkins Questions](#jenkins)
  1. [AWS Questions](#aws)
  1. [Network Questions](#network)



## Jenkins

###### beginner

* Explain what is Jenkins and what is it used for
* Explain each of the following in the context of nodes:
  * Master
  * Slave
  * Executor
  * Agent
  * Label
* Explain each of the following in context of jobs:
  * Job
  * Build
  * Test
  * Artifacts
* Explain the architecture of Jenkins
* What are the different ways to trigger a build?
* How do you start a build automatically upon a change in a certain repository?
* What is a plugin?
  * What plugins are you using in Jenkins? Which do you consider to most useful?
* Installation questions
  * How to install Jenkins?
  * How to install a plugin?
  * How to install an agent?

###### Intermediate

- What type of jobs there are?
- How do you notify users on build results?
  - Can also be asked like that: what ways there are to notify users on build results?

###### Advanced

* Write a script to remove all the jobs which include the string "REMOVE_ME"



## AWS

###### Global Infrastructure

- Explain the following
  - Availability zone
  - Region
  - Edge location

###### S3 - beginner questions

- Explain what is S3 and what is it used for

- What is a bucket?

- True or False? a bucket name must be globally unique

- What objects in S3 consists of?

  - Another way to ask it: explain key, value, version id and metadata in context of objects

- Explain data consistency

  

## Network

Network questions can be found [here](https://github.com/bregman-arie/computer-networking/blob/master/interview_questions/README.md)

